VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTDCWaveform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Sub ZeroMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, ByVal numBytes As Long)
Private Const conMaxChannels = 10
Private Const conMaxVisualSamples = 8192

Private m_lngMinY As Long
Private m_lngMaxY As Long
Private m_lngNumSamples As Long
Private m_blnMixChannels As Boolean
'Private m_lngBuffer(0 To conMaxChannels - 1, 0 To conMaxVisualSamples - 1) As Long
Private m_lngBuffer() As Long
Public Event OnWaveformData(ByRef Data() As Long, ByVal MinY As Long, ByVal MaxY As Long, ByVal NumSamples As Long, ByVal Channels As Long)
Private m_bytSampleSkip As Byte

Private Type T24BitSample
    a0 As Byte  '0 to 255
    a1 As Byte  '0 to 255
    a2 As Byte  '-128 to 127
End Type

Public Property Get Buffer() As Long()
    Buffer = m_lngBuffer
End Property

Public Property Get MinY() As Long
    MinY = m_lngMinY
End Property

Public Property Let MinY(ByVal lngNewValue As Long)
    m_lngMinY = lngNewValue
End Property

Public Property Get MaxY() As Long
    MaxY = m_lngMaxY
End Property

Public Property Let MaxY(ByVal lngNewValue As Long)
    m_lngMaxY = lngNewValue
End Property

Public Property Get NumSamples() As Long
    NumSamples = m_lngNumSamples
End Property

Public Property Let NumSamples(ByVal lngNewValue As Long)
    m_lngNumSamples = lngNewValue
End Property

Public Property Get MixChannels() As Boolean
    MixChannels = m_blnMixChannels
End Property

Public Property Let MixChannels(ByVal blnNewValue As Boolean)
    m_blnMixChannels = blnNewValue
End Property

Public Property Get SampleSkip() As Byte
    SampleSkip = m_bytSampleSkip
End Property

Public Property Let SampleSkip(ByVal bytNewValue As Byte)
    m_bytSampleSkip = EnsureRange(bytNewValue, CByte(1), CByte(255))
End Property

Private Sub Class_Initialize()
    m_blnMixChannels = True
    m_lngMinY = CLng(0)
    m_lngMaxY = CLng(100)
    m_lngNumSamples = CLng(512)
    m_bytSampleSkip = CByte(1)
    Call Flush
End Sub

Public Sub Process(ByVal BufferPtr As Long, ByVal Size As Long, ByVal Bits As Long, ByVal Channels As Byte, ByVal Float As Boolean)
    Dim bytBuf8() As Byte
    Dim intBuf16() As Integer
    Dim udtBuf24() As T24BitSample
    Dim lngBuf32i() As Long
    Dim sngBuf32() As Single   'Delphi Single Data Type
    Dim lngPChannels As Long
    Dim lngNumSamples As Long
    Dim i As Long, c As Long, z As Long
    Dim lngTemp As Long     'tmp
    Dim lngChannels As Long 'ch
    Dim lngRange As Long    'fRange
    Dim lngSkip As Long     'Skip
    
    If (BufferPtr = CLng(0)) Or (Size = CLng(0)) Or (Bits = CLng(0)) Or (Channels = CLng(0)) Then Exit Sub
    lngSkip = CLng(m_bytSampleSkip)
    If lngSkip < CLng(1) Then lngSkip = CLng(1)
    lngNumSamples = Size \ (Bits \ CLng(8)) \ Channels \ lngSkip
    
    If Channels > CLng(conMaxChannels) Then
        lngChannels = CLng(conMaxChannels)
    Else
        lngChannels = Channels
    End If
    
    If m_blnMixChannels Then
        lngPChannels = CLng(1)
    Else
        lngPChannels = lngChannels
    End If
    
    If lngNumSamples > m_lngNumSamples Then lngNumSamples = m_lngNumSamples
    ReDim m_lngBuffer(lngChannels - CLng(1), lngNumSamples - CLng(1))
    
    Select Case Bits
        Case CLng(8)
            ReDim bytBuf8((Size \ LenB(bytBuf8(0))) - CLng(1))
            CopyMemory bytBuf8(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD((bytBuf8((i * lngChannels * lngSkip) + c + z) - CLng(128)) * CLng(256) + CLng(32768))
                        Next z
                    Next c
                    
                    m_lngBuffer(0, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                Next i
            Else
                For i = CLng(0) To lngNumSamples - CLng(1)
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = CLng(0)
                        
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD((bytBuf8((i * lngChannels * lngSkip) + c) - CLng(128)) * CLng(256) + CLng(32768))
                        Next z
                        
                        m_lngBuffer(c, i) = ClipWORD(lngTemp \ CLng(m_bytSampleSkip))
                    Next c
                Next i
            End If
        Case CLng(16)
            ReDim intBuf16((Size \ LenB(intBuf16(0))) - CLng(1))
            CopyMemory intBuf16(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD(intBuf16((i * lngChannels * lngSkip) + c + z) + CLng(32768))
                        Next z
                    Next c
                    
                    m_lngBuffer(0, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                Next i
            Else
                For i = CLng(0) To lngNumSamples - CLng(1)
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = CLng(0)
                        
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD(intBuf16((i * lngChannels * lngSkip) + c) + CLng(32768))
                        Next z
                        
                        m_lngBuffer(c, i) = ClipWORD(lngTemp \ CLng(m_bytSampleSkip))
                    Next c
                Next i
            End If
        Case CLng(24)
            ReDim udtBuf24((Size \ LenB(udtBuf24(0))) - CLng(1))
            CopyMemory udtBuf24(0), ByVal BufferPtr, Size
            
            If m_blnMixChannels Then
                For i = CLng(0) To lngNumSamples - CLng(1)
                    lngTemp = CLng(0)
                    
                    For c = CLng(0) To lngChannels - CLng(1)
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD(Cvt24BitTo32(udtBuf24((i * lngChannels * lngSkip) + c + z)) \ CLng(256) + CLng(32768))
                        Next z
                    Next c
                    
                    m_lngBuffer(0, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                Next i
            Else
                For i = CLng(0) To lngNumSamples - CLng(1)
                    For c = CLng(0) To lngChannels - CLng(1)
                        lngTemp = CLng(0)
                        
                        For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                            lngTemp = lngTemp + ClipWORD(Cvt24BitTo32(udtBuf24((i * lngChannels * lngSkip) + c)) \ CLng(256) + CLng(32768))
                        Next z
                        
                        m_lngBuffer(c, i) = ClipWORD(lngTemp \ CLng(m_bytSampleSkip))
                    Next c
                Next i
            End If
        Case CLng(32)
            If Float Then
                ReDim sngBuf32((Size \ LenB(sngBuf32(0))) - CLng(1))
                CopyMemory sngBuf32(0), ByVal BufferPtr, Size
                
                If m_blnMixChannels Then
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        lngTemp = CLng(0)
                        
                        For c = CLng(0) To lngChannels - CLng(1)
                            For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                                lngTemp = lngTemp + ClipWORD(CLng(Round(sngBuf32((CSng(i) * CSng(lngChannels) * CSng(lngSkip)) + c + z) * CLng(32768) + CLng(32768))))
                            Next z
                        Next c
                        
                        m_lngBuffer(0, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                    Next i
                Else
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        For c = CLng(0) To lngChannels - CLng(1)
                            lngTemp = CLng(0)
                            
                            For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                                lngTemp = lngTemp + ClipWORD(CLng(Round(sngBuf32((CSng(i) * CSng(lngChannels) * CSng(lngSkip)) + c) * CLng(32768) + CLng(32768))))
                            Next z
                            
                            m_lngBuffer(c, i) = ClipWORD(lngTemp \ CLng(m_bytSampleSkip))
                        Next c
                    Next i
                End If
            Else
                ReDim lngBuf32i((Size \ LenB(lngBuf32i(0))) - CLng(1))
                CopyMemory lngBuf32i(0), ByVal BufferPtr, Size
                
                If m_blnMixChannels Then
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        lngTemp = CLng(0)
                        
                        For c = CLng(0) To lngChannels - CLng(1)
                            For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                                lngTemp = lngTemp + ClipWORD(lngBuf32i((i * lngChannels * lngSkip) + c + z) \ CLng(65536) + CLng(32768))
                            Next z
                        Next c
                        
                        m_lngBuffer(0, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                    Next i
                Else
                    For i = CLng(0) To lngNumSamples - CLng(1)
                        For c = CLng(0) To lngChannels - CLng(1)
                            lngTemp = CLng(0)
                            
                            For z = CLng(0) To CLng(m_bytSampleSkip) - CLng(1)
                                lngTemp = lngTemp + ClipWORD(lngBuf32i((i * lngChannels * lngSkip) + c) \ CLng(65536) + CLng(32768))
                            Next z
                            
                            m_lngBuffer(c, i) = ClipWORD(lngTemp \ (lngChannels * CLng(m_bytSampleSkip)))
                        Next c
                    Next i
                End If
            End If
    End Select
    
    lngRange = m_lngMaxY - m_lngMinY
    
    For c = CLng(0) To lngChannels - CLng(1)
        For i = CLng(0) To lngNumSamples - CLng(1)
            'Scale to correct output (for some reason the output isn't the same as in Delphi)
            m_lngBuffer(c, i) = (CLng(2) * m_lngBuffer(c, i)) - CLng(65536)
            
            'Original code
            m_lngBuffer(c, i) = ((m_lngBuffer(c, i) * lngRange) \ CLng(65536)) + m_lngMinY
            
            'Wrapper code (scaled to correct output ranges)
            'm_lngBuffer(c, i) = (((m_lngBuffer(c, i) * lngRange) \ CLng(32768)) - lngRange) + m_lngMinY
        Next i
    Next c
    
    RaiseEvent OnWaveformData(m_lngBuffer(), m_lngMinY, m_lngMaxY, lngNumSamples, lngPChannels)
End Sub

Public Sub Flush()
    Erase m_lngBuffer
    
    'Dim lngChannel As Long
    'Dim lngSample As Long
    '
    'For lngChannel = CLng(0) To CLng(conMaxChannels) - CLng(1)
    '    For lngSample = CLng(0) To CLng(conMaxVisualSamples) - CLng(1)
    '        m_lngBuffer(lngChannel, lngSample) = CLng(0)
    '    Next lngSample
    'Next lngChannel
    '
    'Call ZeroMemory(m_lngBuffer(0, 0), CLng(conMaxChannels) * CLng(conMaxVisualSamples))
End Sub

Private Function ClipWORD(ByVal lngValue As Long) As Long
    If lngValue > CLng(65535) Then
        ClipWORD = CLng(65535)
    ElseIf lngValue < CLng(0) Then
        ClipWORD = CLng(0)
    Else
        ClipWORD = lngValue
    End If
End Function

Private Function Cvt24BitTo32(Sample As T24BitSample) As Long
    If Sample.a2 <= CLng(127) Then
        Cvt24BitTo32 = CLng(Sample.a0) + (CLng(Sample.a1) * CLng(&H100)) + (CLng(Sample.a2) * CLng(&H10000))
    Else
        Cvt24BitTo32 = CLng(Sample.a0) + (CLng(Sample.a1) * CLng(&H100)) + ((CLng(Sample.a2) - CLng(256)) * CLng(&H10000))
    End If
End Function

Private Function EnsureRange(ByVal bytValue As Byte, ByVal bytMin As Byte, ByVal bytMax As Byte) As Byte
    If bytValue < bytMin Then
        EnsureRange = bytMin
    ElseIf bytValue > bytMax Then
        EnsureRange = bytMax
    Else
        EnsureRange = bytValue
    End If
End Function

