Attribute VB_Name = "modDCDSPFilter"
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Const HKEY_CLASSES_ROOT = &H80000000

Public Const CLSID_DCDSPFilter = "{B38C58A0-1809-11D6-A458-EDAE78F1DF12}"
Public Const IID_DCDSPFilter = "{BD78EF46-1809-11D6-A458-EDAE78F1DF12}"
Public Const IID_DCDSPFilterVisual = "{3AA3B85E-FBD5-4D30-8D3C-B78AFC24CE57}"

Public Const IID_IDCAmplify = "{3FB0116F-52EE-4286-BF3A-65C0055EAA45}"
Public Const IID_IDCBandPass = "{0D608545-CEAE-4E19-A6B4-CE516D415C71}"
Public Const IID_IDCChannelOrder = "{567017E8-EBC3-444A-BAAC-7BEA3841EF2E}"
Public Const IID_IDCCompressor = "{E93CF724-B897-4A50-825B-AC8FFDCA937B}"
Public Const IID_IDCDownMix = "{9496B84F-BC7B-4230-889D-1ADCC790D237}"
Public Const IID_IDCDynamicAmplify = "{0B60A7EC-A76F-4526-AE29-FF1FD8EA7DC3}"
Public Const IID_IDCEchoDelay = "{F5803607-1B25-422C-B55A-22305FC40C37}"
Public Const IID_IDCEqualizer = "{14D4A709-77ED-459B-B1E9-E4E4C84261BD}"
Public Const IID_IDCFlanger = "{EB6F78D4-A20D-4115-8924-89A3571DD587}"
Public Const IID_IDCHighPass = "{614F092A-50E0-4BEF-9CD3-B390EB5958A8}"
Public Const IID_IDCLowPass = "{FCAE49B0-005F-4F21-8B7F-555AB3196073}"
Public Const IID_IDCNotch = "{35D3996E-A312-4A8D-BEBA-05A26DBB2F34}"
Public Const IID_IDCParametricEQ = "{A51C1B92-5C17-40FB-A1E2-685F329D97CF}"
Public Const IID_IDCPhaseInvert = "{0102BF81-AEFC-4ACC-9135-DAF0669151BD}"
Public Const IID_IDCPhaser = "{0CFA4706-977A-4B8C-B12F-DDB29B873C3F}"
Public Const IID_IDCPitchScale = "{3484EA9C-4598-469C-9EDB-4AEF85D835A8}"
Public Const IID_IDCPitchShift = "{96979014-AD4E-49F9-A9DE-3BD3A55A4454}"
Public Const IID_IDCSound3D = "{E83F7666-DD0A-4358-A0F0-75E1B8F52062}"
Public Const IID_IDCTempo = "{E25E423C-866D-49CD-B950-CE12A17ED26D}"
Public Const IID_IDCTrebleEnhancer = "{45694F89-26E6-48EC-B2CD-22D7E74BD1C3}"
Public Const IID_IDCTrueBass = "{74EB17C2-ED23-4175-B5B7-26395030BF5D}"

Public Const IID_IDCDMOChorus = "{2F99E23A-5D6E-4B51-8269-49C46ADC745C}"
Public Const IID_IDCDMOCompressor = "{A5BA9E24-E017-48D2-9446-E42E5E1C9DCB}"
Public Const IID_IDCDMODistortion = "{A09AE606-B22B-4C1B-8ACF-45285BC30925}"
Public Const IID_IDCDMOEcho = "{22F654FD-7829-4BB8-9380-14EC6279D6D8}"
Public Const IID_IDCDMOFlanger = "{50CEC6C5-0A67-4BBA-BEC5-A59D86DFC12B}"
Public Const IID_IDCDMOGargle = "{0F5FDB37-E3EA-4556-98E4-790345E28D8D}"
Public Const IID_IDCDMOI3DL2Reverb = "{22D00724-2D31-47E8-A5C4-3FF732224C9B}"
Public Const IID_IDCDMOParamEQ = "{414E947F-0327-4D2F-B3CC-5AAEAB8EC4F2}"
Public Const IID_IDCDMOWavesReverb = "{CB0809E2-8436-475A-B37E-F21BACDD5014}"

Public Sub GetPCMData(ByRef Buffer As Long, ByVal Length As Long, ByRef PCMData() As Byte)
    If Length < CLng(1) Then
        Erase PCMData()
        Exit Sub
    End If
    
    ReDim PCMData(Length - CLng(1))
    CopyMemory PCMData(0), Buffer, Length
End Sub

Public Sub SetPCMData(ByRef Buffer As Long, ByRef PCMData() As Byte)
    On Local Error GoTo ErrHandler
    Dim lngSize As Long
    
    lngSize = UBound(PCMData) + CLng(1)
    CopyMemory Buffer, PCMData(0), UBound(PCMData) + CLng(1)
    On Local Error GoTo 0
    Exit Sub
    
ErrHandler:
    Err.Clear
    On Local Error GoTo 0
End Sub

Public Function DCDSPFilterInstalled() As Boolean
    Dim lngKeyHandle As Long
    Dim lngReturn As Long
    Dim strValue As String
    
    lngReturn = RegOpenKey(HKEY_CLASSES_ROOT, "CLSID\" & CLSID_DCDSPFilter, lngKeyHandle)
    
    If lngReturn <> CLng(0) Then
        DCDSPFilterInstalled = False
        Exit Function
    End If
    
    DCDSPFilterInstalled = True
    lngReturn = RegCloseKey(lngKeyHandle)
End Function

